Discussion Thread of CodeNation Innovation Labs Hiring Challenge held on 26 January 2021.

**PROBLEM 1 :-**

**Statement**

**Sample Test Cases**

**Extra Test Case**

**PROBLEM 2 :-**

**Statement**

**Sample Test Cases**

**PROBLEM 3 :-**

**Statement**

**Sample Test Cases**

**PROBLEM 4 :-**

**Statement**

**Sample Test Cases**

**PROBLEM 5 :-**

**Statement**

**Sample Test Cases**

**PROBLEM 6 :-**

**Statement**

**Sample Test Cases**

**PS :- THE CONTEST HAS ENDED. THOSE WHO HAVE PARTICIPATED CAN SHARE THEIR SOLUTIONS. INTERESTED NON — PARTICIPANTS CAN ALSO SHARE THEIR APPROACHES.**

Video Editorial with Scoring Distribution: https://youtu.be/8tEXXSc351c

Problem 1:Observation 1: Notice that the left arrows will form a prefix of any row. L U L can be made L U U without affecting anything. Observation 2: The number of left arrows will decrease as we go from the bottom row to the top row.

These 2 solutions lead to a $$$O(N\cdot M)$$$ DP where N, M are the dimensions of the rectangle.

Problem 2:Observation 1: If any bit is set in >= 2 numbers in the range, answer is 0. So we can compute prefix frequencies for each bit. Observation 2: Answer will atmost be 2 because we can make the last bit 1 (having two odd integers in the range is sufficient).

So, with the prefix computation, if answer is not 0, it is 2 — (number of odd integers in the range). Solution complexity: $$$O(N + Q)$$$

Problem 3:Simple implementation problem — just store the frequency of every number. Answer = Sum of initial array. Then, ans = min(ans, sum — freq(val) * val) for all values. Solution complexity: $$$O(N)$$$Problem 4:We can have a $$$O(N \cdot M)$$$ DP, where DP(i, j) stores the number of ways of spending i days, where at the last day, we did an activity of type j, adhering to all the constraints. Using prefix summations, we can get the transitions in O(1) time.

Problem 5:Observation 1: The order of the elements does not matter — we can swap any two elements doing the mentioned operations, and also get the xor of any subset of elements.

Observation 2: The above leads to Gaussian elimination based solution — we only care about the basis (linearly independent set) of elements in the array, since we can get all other XORs from it. Thus, the problem is reduced to finding the basis with the smallest sum. We can do this by finding any basis, and reduce the larger basis elements using the smaller ones.

Solution code: http://p.ip.fi/-1b1

Problem 6:Observation 1: The required node is basically the LCA of all the leaf nodes in the range [L, R]. Observation 2: If we do a DFS order traversal of the tree and store the discovery time of every node, then we only care about finding LCA(first discovered leaf node, last discovered leaf node) in the query range, because all the other nodes lie in between.

Using this, we can solve the problem in $$$O(N \log N)$$$ using various techniques.

Did the questions have uneven points distribution or the same points for every question?

The harder problems had a higher score weightage. $$$P_3 < P_2 < P_1 = P_4 < P_6 < P_5$$$.

JUST CURIOUSVarious questions were given the InterviewBit team and I was responsible for reviewing the questions. So we are not the setters, more like coordinators/reviewers.

Why not show this to participants?

Can you elaborate D a little more ?

Can you provide a rough estimate of the scores.

Due to this the people who did if else, if else for 3 hours will get more point than someone who solved genuinely.

How?

Did you give the last codenation test. If you look at the leaderboard, you will see some people who solved no question fully had better ranks than the one who solved 2 or 3 questions. This was due to the problems uneven marking and interviewbit's system of telling the failed case to certain limit.

ProofLook at the person on 364th rank. If you go on to the next 10 pages you will see more of them. https://www.interviewbit.com/contest/codeagon-2020/scoreboard?page=19#

Problem 6: Segment Tree + LCA

Video editorial will be very cool. Ashishgup

Yeah Ashishgup

Sure, I'll consider making a video editorial on it tomorrow if enough people are interested :)

It'd be awesome if you could do so

I've uploaded the solutions: https://youtu.be/8tEXXSc351c

Thanks a lot, highly appreciated

plus please make these questions available to some platform so that we can solve these questions properly with proper test cases.

Can you elaborate on problem 4?

Like what will the recurrence relation look like?

yes, dp[day][lastact][streak] is very intuitive but how to reduce it to n^2

remove streak from dimension, and move it transitions instead. then it can be optimized by prefix sums.

Can you please elaborate on how to do that ? Coz I was able to solve it with dp[day][lastact][streak] But couldn't optimize it and it obviously gave TLE and I want to learn how to solve this very badly :( Please please help!!!

$$$dp[i][j] = \sum\limits_{l=1}^{A_j}\sum\limits_{k=1}^{m} dp[i-l][k] - \sum\limits_{l=1}^{A_j}dp[i-l][j]$$$. You can simplify this by defining $$$pre[i][j] = \sum\limits_{l=1}^{i} \sum\limits_{j=1}^{m} dp[i-l][j]$$$

In problem 4, we need to define $$$dp[0][j] = \frac{1}{m-1}$$$. So we define $$$dp[0][j] = 1$$$ and divide the final obtained value by $$$(m-1)$$$. Or was there some easy way to define base cases?

Suppose we want answer for dp[i][j] and

i-A[j]<=0, this is the only case we will be using dp[0][j]. Whenever we encounter this case, we canexplicitly add 1to dp[i][j] instead of defining dp[0][j]=1 and dividing it later. This will solve the issue.Will the ranklist be revealed?

For

problem 6, we can notice that LCA can be thought of as a monoid operation, so we can make a normal segtree on the range [1...N] and store the LCA in the segtree nodes. (we can store -1 corresponding to non-leafs, which will work as an identity element: LCA(x,-1) = x = LCA(-1,x))To make it better we can notice that LCA(X,X) = X, so it is also idempotent, so we can use a sparse table as well. Which gives us a fast solution. $$$O((NlogN+Q) * f(N))$$$. Where $$$f(N)$$$ is the time in which you calculate LCA ($$$O(logN)$$$ or $$$O(1)$$$ depending on how you do it)

P2: answer can be 1 as well. if in the range, we already have an odd number, then we can add 1 to any even number and their AND will be > 0

Please answer this if you have any suggestions.

SpoilerHow do you actually get Ideas while you are stuck. I was trying to do the same problems yesterday. The basis question, I observed that the positions doesn't matter but was not able to get to the actual answer. I ended up having ith bit set if any of the numbers have that bit set. (Lead to WA).

Similarly, I was trying out the Little Pony question using DP but was not able to get to the final answer. More specifically, I was unable to re-arrange the activities, I was stuck in dp[i%2][j] = dp[(i+1)%2][j-k]+dp[(i+1)%2][j]; Realised that this would not rearrange the activities.

Any suggestion would be appreciated. (Also I am practising with keeping question ratings in mind)

Can you elaborate D problem a bit more . It will be helpful if you can make a video tutorial on it.Thanks.

can the answer for the fifth problem be the bitwise OR of all the elements? if no ,than why plz explain.

For problem 3 , we will make a hashmap which stores the frequency of each element . Iterate through hashmap and find maximum value of x = ( key * value) . Answer is simply sum of elements in the array — x;

In problem 6, was Farach Colton LCA the intended solution to find LCA without MLE? or was segment tree solution for LCA sufficient?

Yes,Lca with segment tree was sufficient.

Could you plz explain how to find the lca using segment tree here , I was able to get the observation required but wasn't able to find a way for lca.

just use standard min/max segtree, and change min()/max() to lca().

also, have lca(leaf, non-leaf) = leaf to get lca of leafs only.

for computing lca(a, b) use any standard way.

oh, nice method, I have never done a problem like this before. Also did you solve all the problems XD

in the first sample case my ans[-1,3] AC->is [-1,5] but lca(3,5) is 3 then why 5 is considered?

Because only the lca of leaf nodes having the label within the given range is asked,you are finding the lca of a internal and a leaf node.

thanks a lot.

I think it is possible to solve it without LCA using in time and exit time.Then the problem reduces to binary search on a segment tree which is more memory efficient than normal LCA.

can anyone please explain problem statement of problem 1 , i could'nt even understand problem clearly , i tried hard to understand but couldnt ..plz explain anyone..

This is problem 4 — Problem

How do you guys come to know about these contests? Can anyone participate?

LinkendIn and Codenation social pages.

I solved

`P2`

,`P3`

and`P6`

is there any probability I may get a call?Depends on how many people gave the test and how many peeps CN are going to interview, which might be revealed in some days.

Hey, did you got any response or anything? If yes, please let me know.

No i couldn't solve that many problems to expect a response :(, also i am not sure if they will even hire from this test because of all the cheating and since they are hiring through codechef as well.But for a more sure answer you can ask ashishgup.

So I was wrong, people who solved at least 4 did got interview calls.

Oh!, Thanks for info

Will I get the internship interview opportunity ? I solved first 3 Questions. Ashishgup

can anyone post the solutions of problem 4?

The comment is hidden because of too negative feedback, click here to view it

Are the problems available for practice on any platform?

Can someone explain 5th question solution in a more detailed way? It will be better if you can mention the required mathematical concepts properly.

Ashishgup, could you please tell whether the testcases on which the solutions were tested at the time of the contest were only pretests or full testcases.

After being asked to do it by multiple people, I finally made a video explanation of all of these problems on my youtube channel.

So will the answer for fifth problem just be the bitwise OR of all the numbers according to the second solution you explained

No it won't be just bitwise OR of all numbers (I actually implemented this during contest and got WA xD) Let's say for some bit B you can have a situation of not having an element whose

highestset bit is B , and provided that B is set in some elements.Consider the case 3,6. The answer is 8 but the bitwise OR is 7.

(In particular, the answer will be equal to bitwise OR if all non-zero bits are linearly independent)

I see it now, thanks for replying :)

So do we have to apply brute force in this case? will it not get TLE

Can someone please elaborate if there is anything wrong with the following code for 1st problem(rectangular field) as the following code gives 45 answer for the first testcase (although the answer is 65 as shown above)but still this solution is accepted on online platforms?

## include

## include

using namespace std;

int n,m,P1[500][500],P2[500][500],FR[501][501],FC[501][501],dp[501][501];

int main(){ while(1){ scanf("%d %d",&n,&m); if(n==0) break;

}

i solved 2 problem can i get shortlist

can anyone provide the contest link so I can practice the problems?